;===============================================================================
; I-nbi lugejaga/salvestaja "aadressiraamat". Baseerub I-nbiga lukul 
; felch@staff.ttu.ee
; 3.8.: alustame. Nbi lugemine ja LCD ttavad.
; 7.8.: teeme saatmise. Ttab aga msikiprast peab work0..tagurpidi lugema ja nihutama kah!? Vea  kontroll maas!!!
; 8.8.: salvestamine, kuvamine ja kustutamine.Parandada klaverit (release!), mensid.
; 9.8.: klaveri rutiini parandus, main_00 ikka paha mte. Nime sisestus olemas.
;===============================================================================

	LIST    p=16F628  	; Nimetame prose

	#include "P16F628.INC"  	
				errorlevel -302					; Compaileri vingumised ra
				errorlevel -305
;				errorlevel -306 

	__CONFIG _WDT_OFF&_INTRC_OSC_NOCLKOUT&_PWRTE_ON&_CP_OFF&_MCLRE_OFF&_BODEN_ON&_LVP_OFF

;*********************** Raudvrk **********************************************
;*** vljundid ***
#define Ibut			PORTA,1					; nbi sisend/vljund
#define	Tris_button		TRISA,1
#define Fbut			PORTB,0					; lugeja nbi emuleerimise I/O
#define	Tris_Fbutton	TRISB,0
#define LED				PORTB,3					; taskulambi LEDi juhtimine (PWM), aktiivne = HIGH.
#define NokClk			PORTA,2
#define NokDat			PORTA,3
#define NokD_C			PORTA,6					; 1=data, 0=cmd
#define NokCS			PORTA,7					; aktiivne=LOW
;#define TxD			PORTB,2					; seriali otc
;*** sisendid ***
;#define N_ent			PORTB,0					; nupp ENTER/toide, aktiivne = LOW
#define N_1				PORTB,4					; nupp 1, aktiivne = LOW
#define N_2				PORTB,5					; nupp 2, aktiivne = LOW
#define N_3				PORTB,6					; nupp 3, aktiivne = LOW
#define N_4				PORTB,7					; nupp 4, aktiivne = LOW
;#define RxD			PORTB,1					; seriali otc
nupp1					equ	0xE0				; esimese (vasakult) klahvi kood
nupp2					equ	0xD0				; teise klahvi kood
nupp3					equ	0xB0				; kolmanda klahvi kood
nupp4					equ	0x70				; neljanda klahvi kood
; ********************** constantsid *******************************************
#define	T1resoL			0xF0
#define	T1resoH			0xD8					; 10mS @ 4 MHz
#define	serialtime		0x02					; 10 ms ksu laekumise aega alates 1. baidist
#define	keytime			0x07					; 70 ms nupu debounce aeg
#define	rdrtime			0x03					; 30 ms aega ukseluku sideks. Kui lheb kauem, on jama.
#define UserTimeH		0x02;F4					; 30 sekundit on aega vidin lugejasse torgata ja kood ra saata
#define UserTimeL		0xB8;47
#define	IbaitCount		0x08					; nbi daatas on 8 baiti
#define	IbitCount		0x08					; igas baidis on 8 bitti
#define maxentries		0x08					; niimitme nbi data mahub mllu
#define	ndebounce		0x03					; nupu debounce aeg				
;#define	nshort			0x3F					; nupu lhikese vajutuse aeg				
#define CARRY           STATUS,C 
#define ZERO            STATUS,Z 
#define pank            STATUS,RP0
; ********************** EEPROM *************************************************
#define num1			0x00					; esimese I-nbi numbrikoht (8 baiti) EEPROMis
#define nimi1			0x08					; samale kohale vastav nimi (kuni 8 mrki)
#define num2			0x10					; teine number
#define nimi2			0x18					; teine nimi 
#define num3			0x20					;
#define nimi3			0x28					; 
#define num4			0x30					; 
#define nimi4			0x38					; 
#define num5			0x40					; 
#define nimi5			0x48					; 
#define num6			0x50					; 
#define nimi6			0x58					;  
#define num7			0x60					; 
#define nimi7			0x68					; 
#define num8			0x70					; 
#define nimi8			0x78					; 
; ************** Mlu jaotus **********	    	
				cblock 0x20						; kuni 7F
;***** I-nbi asjad ****
					work0                       ; CRC (8 bitti)
					work1                       ; Serial # (48 bitti)
					work2                       ; "
					work3                       ; "
					work4                       ; "
					work5                       ; "
					work6                       ; "
					work7                       ; Family Code (8 bitti)
					OneWireByte
					SOURCE
					DEST
					TEMP0
					TEMP1
					TEMP2
					tempone	
					temptwo

					rombit_idx
					bits
					ctr_1wire
					curr_discrep
					last_discrep
					t_count
;***** ssteem ****
					W_Temp
					S_Temp
					count		
					Flags				
					Flags1
					serialtimer
					keytimer
					t1_count	
					Lath_TMP			
					rdrtimer
					UserTimerH
					UserTimerL
;***** RS232 *****
					RxPointer
					Puhver:.30					; seriali vastuvtu puhver, kuni 30 baiti,
					bytecnt
;***** LCD *******
					temphex2lcd
					tmp;OK
					Table_Temp
					Table_hitmp					; tabeli MSB-aadressi korrektcioon
					LCD_Count
					large_count
					Messi_nr
					lcdtmp
					dispX
					dispY
					Lath_tmp
					msg_tmp
;**** klaver ja tema taimerid *****
				n1timer
				keypress
				keypress1
;**** EEPROM *******
					freemem						; vabade kohtade arv
					firstfree					; esimene vaba aadress
              endc

; ************* Lipud ****************	    	
#define done_flag	Flags,0				
#define	keypressed	Flags,1						; 1 kui klahv vajutatud
#define	released	Flags,2						; 1 kui nupp vabastatud peale vajutust
#define	Dataok		Flags,3				 
#define	ButRead		Flags,4						; np loetud, ootame et ta eemaldataks
#define KeyPressed	Flags,5						; valiidne nupu vajutus olemas
#define	ButTimeOut	Flags,6						; nbi lugemise timeout
#define return_value Flags,7
		
#define UserTimerOn Flags1,0					; tskli ldine taimer kib
#define UserTimeOut Flags1,1					; tskli aeg (30s) otsas
#define viga		Flags1,2					; vea ja muidu abilipp
#define	RdrTimeOut 	Flags1,3					; timeout ukselukuga suheldes
#define	RdrTimerOn 	Flags1,4					; 1-wire suhluse taimer kib
#define	RdrDetect	Flags1,5					; lugeja on saatnud reseti ja oleme sellele vastanud
#define	invtxt		Flags1,6					; 1 kui inverteerime teksti ekraanil (mustal taustal valge kiri)
#define	already		Flags1,7					; 1 kui loetud np on juba mlus olemas
; *****************************	    	
 org         0x2100								; EEPROMi sisu algselt nulla tis
				dt		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00	
				dt		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00	
				dt		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00	
				dt		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00	
				dt		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00	
				dt		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00	
				dt		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00	
				dt		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00	

;===============================================================================
; *** ja hakkab pihta...
;===============================================================================
              org         0x000
              goto        main
;===============================================================================
; *** Katckestus ...
;===============================================================================
Interrupt:        
				org     0004h 
Push    		movwf   W_Temp           		; seivi kontekst         
				swapf   STATUS,W         
				movwf   S_Temp           		   
				bcf     pank
Disable_Int: 	bcf     INTCON,GIE       		; keela katckestused        
				btfsc   INTCON,GIE       		       
				goto    Disable_Int      		
         
				btfsc   PIR1,TMR1IF      		; Taimer1 (aeg npi ksitleda)?         
				goto    Timer1_Int        		
Pop     			
				swapf   S_Temp,W         
				movwf   STATUS           		; taasta kontekst
				swapf   W_Temp,F         
				swapf   W_Temp,W         		
				retfie                   		; vlja siit, jta intsid lubatux (GIE  !)
;===============================================================================
; *** Taimeri katckestus ...
;===============================================================================
Timer1_Int: ;   	bcf     pank		 
				bcf     PIR1,TMR1IF    			; katkestuse nue maha   
				bsf		ButTimeOut		 		; mrk et on aeg npi lugeda
				call	klaver					; loe klaviatuuri
				btfss	UserTimerOn				; koodi saatmise tskkel kib?
				goto	T1int_7					; ei
				decfsz	UserTimerL,F			; jah, vhenda teda
				goto	T1int_7
				movf	UserTimerH,W
				btfsc	ZERO
				goto	T1int_2
				decfsz	UserTimerH,F
				goto	T1int_7
T1int_2:		bcf		UserTimerOn				; null! Taimer stopp ja taimaudi lipp
				bsf		UserTimeOut
T1int_7:		goto	Pop
;===============================================================================
; ******* Hakkame pihta... *******
;===============================================================================
main_00:	 	call	wait_n_up				; oota nupu vabastamist
				goto	main_0					; ESC ehk peamensse
main:			call	init					; maja korda
				call	Init_LCD				; LCD-l samuti
				call	mainos					; reklaamime veica...
				movlw	'I'						; teatame, et oleme elus
				call	send_dat
				movlw	'-'
				call	send_dat
				movlw	'B'
				call	send_dat
				movlw	'u'
				call	send_dat
				movlw	't'
				call	send_dat
				movlw	't'
				call	send_dat
				movlw	'o'
				call	send_dat
				movlw	'n'
				call	send_dat
main_0:			call	maindisp				; joonista tekraan
				bsf		T1CON,TMR1ON
main_1:			btfss	keypressed				; ootame klahvi pressimist
				goto	main_1
				movf	keypress,W
				sublw	nupp1
				btfsc	ZERO
				goto	read_button				; loeme uue nbi sisse
				movf	keypress,W
				sublw	nupp2
				btfsc	ZERO
				goto	snd_button				; ava uks ehk saada nbi kood fonolukule
				movf	keypress,W
				sublw	nupp3
				btfsc	ZERO
				goto	del_button				; kustuta mrgitud nupp
				movf	keypress,W
				sublw	nupp4
				btfsc	ZERO
				goto	new_button				; sisesta ksitsi uue nbi daata
				call	wait_n_up				; oota nupu vabastamist
				goto	main_1					; loeme veel ...
snd_button:
del_button:
new_button:
				call	wait_n_up				; oota nupu vabastamist
				goto	main_0

read_button:	movlw	.0						; rida 2 pos. 0
				movwf	dispX
				movlw	LOW mess_10-LOW mess_0	; kirje 10 "Sisesta I-np" 
				movwf	Messi_nr
				movlw	0x02
				call	print_msg_XY
				call	wait_n_up				; oota nupu vabastamist, siis tegutse edasi
				movlw	UserTimeH				; lae ldise ooteaja taimer (30 sekundit)
				movwf	UserTimerH
				movlw	UserTimeL				
				movwf	UserTimerL
				bcf		UserTimeOut
				bsf		UserTimerOn				; taimer kima
				bcf		ButTimeOut		 		; ootame aega, ei kia pidevalt
read_button_1:	btfss	ButTimeOut				; on ?
				goto	read_button_1			; ei veel
				bcf		INTCON,GIE
		       	call    Ibut_init				; nbi reset
				call    Search_1Wire     		; otsi npi heinakuhjast ja loe kui saad
				bsf		INTCON,GIE
             	btfss   return_value	  		; np vastab ?
	            goto    read_button_4	     	; eip !
;				bsf		LED
				call	send_but				; saada daata minema (seriali, testiks)
				movlw	0x00					; kustuta rida: rida 2 pos. 0
				movwf	dispX
				movlw	LOW mess_14-LOW mess_0	; kirje 14: thikud
				movwf	Messi_nr
				movlw	0x02
				call	print_msg_XY	

				movlw	0x00					; rida 2 pos. 0
				movwf	dispX
				movlw	LOW mess_2-LOW mess_0	; kirje 2 "Nbi daata:" 
				movwf	Messi_nr
				movlw	0x02
				call	print_msg_XY	
				movlw	.0						; rida 4 pos. 0
				movwf	dispX
				movlw	0x03
				call	goto_XY	
				call	print_but				; trki nbi daata skriinile
				call	check					; kas juba mlus olemas?
				btfss	already
				goto	read_button_1a
				movlw	.12						; rida 5 pos. 2
				movwf	dispX
				movlw	LOW mess_13-LOW mess_0	; kirje 13 "Juba olemas!" 
				movwf	Messi_nr
				movlw	0x04
				bsf		invtxt					; tekst inversioonis
				call	print_msg_XY	
				movlw	0x00					; kustuta vana menrida: rida 6 pos. 0
				movwf	dispX
				movlw	LOW mess_14-LOW mess_0	; kirje 14: thikud
				movwf	Messi_nr
				movlw	0x05
				call	print_msg_XY	
				goto	read_button_2

read_button_1a:	movlw	0x00					; kustuta vana menrida: rida 6 pos. 0
				movwf	dispX
				movlw	LOW mess_14-LOW mess_0	; kirje 14: thikud
				movwf	Messi_nr
				movlw	0x05
				call	print_msg_XY	

				movf	freemem,W				; kui mlu tis, ei luba salvestada
				btfsc	ZERO
				goto	read_button_2			; tis, ainult vaatamine
				movlw	0x00					; uue buttoni men: rida 6 pos. 0
				movwf	dispX
				movlw	LOW mess_11-LOW mess_0	; kirje 11 "Save" 
				movwf	Messi_nr
				movlw	0x05
				bsf		invtxt					; tekst inversioonis
				call	print_msg_XY	
read_button_2:	movlw	.66						; rida 6 pos. 11
				movwf	dispX
				movlw	LOW mess_12-LOW mess_0	; kirje 12 "ESC" 
				movwf	Messi_nr
				movlw	0x05
				bsf		invtxt					; tekst inversioonis
				call	print_msg_XY	
read_button_3a:;	bcf		keypressed
				;clrf	keypress
				;bcf		released
read_button_3:	btfss	keypressed				; ootame juuseri valikut
				goto	read_button_3
;				bcf		keypressed
				movf	keypress,W
				sublw	nupp1
				btfsc	ZERO
				goto	save_button				; seivi nbi daata
				movf	keypress,W
				sublw	nupp4
				btfsc	ZERO
				goto	main_00					; peamensse
				call	wait_n_up				; oota nupu vabastamist
				goto	read_button_3			; loeme veel ...

read_button_4:	bcf		ButRead					; ei vastanud, jrelikult veti ra vi ei olnudki. Lubame jlle lugemise
				bcf		ButTimeOut		 		
				btfss	UserTimeOut				; on veel aega lugeda?
				goto	read_button_1			; jah
				call	clr_scr
				call	rdr_res_x				; sai siiber
;				call	wait_n_up				; oota nupu vabastamist
				goto	main_0
;	call Tx_1wire
save_button:	movlw	0x00					; menrida: rida 5 pos. 0
				movwf	dispX
				movlw	LOW mess_17-LOW mess_0	; kirje 17: nooltega men
				movwf	Messi_nr
				movlw	0x05
				call	print_msg_XY	
				movlw	.18						; rida 4 pos. 3
				movwf	dispX
				movlw	0x04
				call	goto_XY					; nime kirjutamise pos.
				call	char_input				; lase juuseril mingi nimi (kuni 8 char'i) sisestada
;				movf	freemem,W				; kui mlu tis, ei luba salvestada
;				btfsc	ZERO
;				goto	save_button_2			; tis, minema siit
;				btfsc	already
;				goto	save_button_2			; juba olemas, minema siit
				movf	firstfree,W				; arvuta nbi daata seivimise koht
				movwf	t1_count
				movlw	work0					; soorts
				movwf	FSR
				movlw	IbaitCount*2			; nbi baitide arv + nime baitide arv (16)
				movwf	count
save_button_1:	movf	INDF,W
				call	writed					; kirjuta
				incf	FSR,F					; nekst soorts
				incf	t1_count,F				; nekst dest.
				decfsz	count					; kuni kllalt...
				goto	save_button_1
				goto	main_00					; peamensse		
;save_button_2:	call	wait_n_up				; oota nupu vabastamist
;				goto	read_button_3a			; minema siit
;===============================================================================
; ********************** I-nbi funktsioonid **********************************
;===============================================================================
;===============================================================================
; ********************** nbi reset *******************************************
;===============================================================================
Ibut_init:	 	movlw	work0					; nulli nbi tala (21 baiti)
				movwf	FSR
				movlw	.21
				movwf	count
				clrw							
Ibut_init1:		movwf	INDF					
				incf	FSR,F
				decfsz	count
				goto	Ibut_init1
				clrf	last_discrep
				bcf		Dataok					; np veel lugemata
				bcf		ButRead
				return
;===============================================================================
; ******* otsi npi *******
;===============================================================================
Search_1Wire: bcf	    return_value     		; tagastuse lipp nulli
Do_reset:     call      Reset_1wire				; nbile saabast
              clrf      rombit_idx       		; set rom bit index to 1
              incf      rombit_idx, F
              clrf      curr_discrep     		; info ttlemise marker 0-i
              movlw     0xF0            		; "Search Rom" ksk
              movwf     OneWireByte
              call      Sendbyte_1wire   		; saada ksk
Get_2bits             
              call      Readbit_1wire    		; loe bitt bussilt
              movwf     bits             		; seivi
              bcf		CARRY                  
              rlf       bits,F          		; nihuta bitt A vasakule
              call      Readbit_1wire    		; loe bitt B bussilt 
              iorwf     bits,F			        ; seivi

              movf      bits,W

lookup_1x:    addwf     PCL, F           		; dekodeeri loetud bitt
              goto      bits_00          		; collisioon !
              goto      bits_01          		; loeti 0
              goto      bits_10          		; loeti 1
              goto      bits_11          		; nobody home...

bits_00:      movf      rombit_idx,W			; collisioon !
              xorwf     last_discrep, W
              btfss     ZERO			       	; rombit_idx = last_discrep ?
              goto     	_chknxt          		; Ei, checki edasi
              movlw     b'10'            		; Jepp , oletame, et loeti 1
              movwf     bits
      movf		PCLATH,W
			  movwf 	Lath_TMP
              call      Store_Bit        		; salvesta 1 talasse
			  movf		Lath_TMP,W
			  movwf		PCLATH
              goto      ack_bus

_chknxt:      movf      last_discrep,W	    	; saa jooxev biti pos.
              subwf     rombit_idx, W    		; vrdle eelnevaga
              btfss     CARRY       			; irombit_idx > last_discrep
              goto     _chknx2          		; ei 
              movlw     b'01'            		; Jepp , oletame, et loeti 0
              movwf     bits
      movf		PCLATH,W
			  movwf 	Lath_TMP
             call      Store_Bit
			  movf		Lath_TMP,W
			  movwf		PCLATH
              movf      rombit_idx,W			; rombit_idx = Icurpos
              movwf     curr_discrep
              goto      ack_bus

_chknx2:
;does rombits(rombit_idx) = 0 ?
      movf		PCLATH,W
			  movwf 	Lath_TMP
              call      GetWorkBit       		; get bit located at work(rombit_idx)
              movwf     TEMP0            		; and save
			  movf		Lath_TMP,W
			  movwf		PCLATH

              movf      TEMP0,w

lookup_2x:    addwf     PCL, F           		; quik test for 0 or 1
              goto      _zero            		; was 0
_one:                                     		; was 1
              movlw     b'10'            		; Pretend we read a 1
              movwf     bits
              goto      ack_bus
_zero:
              movlw     b'01'            		; Pretend we read a 0
              movwf     bits
              movf      rombit_idx,W			; set discrepancy marker to rombit_idx
              movwf     curr_discrep
              goto      ack_bus
              
bits_01:      goto      _storit					; 0 received
bits_10:                                  		; 1 received
_storit:      movf		PCLATH,W
			  movwf 	Lath_TMP
			  call      Store_Bit        		; Save it into work area at rombit_idx offset
			  movf		Lath_TMP,W
			  movwf		PCLATH
; Send rombit(rombit_idx) to 1-wire bus
ack_bus:	  bcf		CARRY
              rrf       bits,W          		; get bit A into W
              call      Sendbit_1wire    		; send bit A to wire
; Increment rombit_idx
              incf      rombit_idx, F    		; bump pointer to next location
; Is rombit_idx > 64?
              movf      rombit_idx,W	        ; see if index > 64
              sublw     d'65'            		; (i.e. = 65)
              btfss     ZERO
              goto      Get_2bits        		; if not, loop back for more

              movf      curr_discrep,W			; set last discrepancy to descrepancy marker     
              movwf     last_discrep
              btfsc     ZERO   					; is last discrepancy = 0?  
              bsf	    return_value
              goto      Wrapup
              
bits_11:      clrf      last_discrep			; nothing answered on the bus
              goto      Wrapup             
Wrapup:       return
;===============================================================================
; ******* I-nbi reset *******
;===============================================================================
Reset_1wire:	bcf 	Ibut	               	; nbi otc madalax
				movlw	0xAA					; oota 515 uS
				call	wait_x
	            bsf 	Ibut	                ; krgex
				movlw	0xAA					; oota 515 uS
				call	wait_x
              	return
;===============================================================================
; ******* saadab ksubaidi registrist OneWireByte I-nbile *******
;===============================================================================
Sendbyte_1wire:	movlw	0x08					; 8 bitti
              	movwf   TEMP0
_send_1w_lp:    clrf    TEMP1            		; Clear work area
              	bcf     TEMP1,0			        ; Assume sending 0
              	bcf		CARRY                   ; Fill new bits with 0
              	rrf     OneWireByte,F   		; Load CARRY with bit to send
              	btfsc   CARRY			        ; See what we are sending
               	bsf     TEMP1,0         		; must be a 1
              	movf    TEMP1,W		            ; Load up the bit and
              	call    Sendbit_1wire    		; send it out
              	decfsz  TEMP0,F         		; 8 bitti ok ?
               	goto     _send_1w_lp      		; vara veel
              	return
;===============================================================================
; ******* saadab ksubiti I-nbile *******
;===============================================================================
Sendbit_1wire:  movwf   TEMP1
              	bcf     Ibut	         		; np madalax
              	btfsc   TEMP1,0 
               	bsf     Ibut	        		; pulsi lpp kui bitt oli 1
				movlw	0x11					; (Tslot + Trec) - Tlow1 = 59uS
				call	wait_x
	            bsf     Ibut	        		; pulsi lpp kui bitt oli 0
              	nop    							; Trec
	            return
;===============================================================================
; ******* loeb vastusbaidi A/B I-nbist registrisse OneWireByte *******
;===============================================================================
Readbyte_1wire:	movlw   d'8'
               	movwf   TEMP0
_read_1w_lp:   	call    Readbit_1wire
               	movwf   TEMP1            		; Save the bit read
               	bcf		CARRY                   ; Assume bit is 0
              	btfsc   TEMP1,0         		; Check bit
               	bsf		CARRY                  	; its a 1
              	rrf     OneWireByte, F   		; Rotate bit into IO area
	            decfsz  TEMP0,F		 	        ; 8 bitti OK?
               	goto     _read_1w_lp      		; vara veel
              	movf    OneWireByte,W		    ; jah, tulemus W-sse
              	return                     ;
;===============================================================================
; ******* loeb vastusbiti I-nbist *******
;===============================================================================
Readbit_1wire:	bcf    	Ibut	         		; nbi taktipulss - madalax
				nop
	            bsf    	Ibut	         		; taktipulss - krgex
				bsf		pank					; llitame nbi otca sisendiks
				bsf		Tris_button
				bcf		pank
	            clrf    TEMP1            		; oletame, et tuleb 0
				movlw	0x03					; oota ca 13uS
				call	wait_x
 	            btfsc   Ibut	         		; mis tuli ?
                bsf     TEMP1,0			        ; peab olema 1
				movlw	0x0E					; oota 49uS
				call	wait_x
              	movf    TEMP1,W
				bsf		pank					; llitame nbi otca vljundiks
				bcf		Tris_button
				bcf		pank
	            return
; *************************************************************************************************************
; ************************ Klaveri funktsioonid ***************************************************************
; *************************************************************************************************************
; *************************************************************************************************************
; ************************ Loeb klaverit  *********************************************************************
; *************************************************************************************************************
klaver:			movf	PORTB,W
				andlw	0xF0					; kustutame tarbetud LCD bitid
				movwf	keypress1				; vajutatud ?
				sublw	0xF0
				btfss	ZERO
				goto	n1_down					; vajutus detektitud !
				btfsc	keypressed				; oli enne vajutus?
				goto	n1_up					; jah
				bcf		released				; ei, mingi krbin vaid. 
				goto	n1_err					; Nulli muutujad.

n1_up:			movf	n1timer,W				; lahti lastud
				sublw	ndebounce
				btfsc	CARRY					
				goto	n1_end2					; aga veel liiga lhikest aega
;				goto	n1_end1					; vajutuse lpp
n1_end1:;		bcf		keypressed				; piisavalt kaua lahti lastud
				bsf		released				; mrka seda!
n1_err:			clrf	n1timer					; liiga lhike vajutus (hire), unustame 
				return
				goto	n1_err
n1_down:		btfsc	keypressed				; juba oli vajutus?
				return							; jah, ignoreeri
				movf	n1timer,W				; piisavalt kaua vajutatud ?
				sublw	ndebounce
				btfsc	CARRY					
				goto	n1_end2					; veel liiga lhikest aega
				movf	keypress1,W				; seivi klahvi kood
				movwf	keypress
				bsf		keypressed
				clrf	n1timer
				return
n1_end2:		incf	n1timer,F				; suurendame loendit
				return
wait_n_up:		btfss	released				; oota klahvi vabastamist
				goto	wait_n_up
				bcf		released				; valmis
				bcf		keypressed
;				clrf	keypress
;				clrf	keypress1
				return
; *************************************************************************************************************
; ******************** laseb sisestada kuni 8 smbolit  *******************************************************
; *************************************************************************************************************
char_input:		clrf	rombit_idx				; seivitava pos. pointer
				clrf	ctr_1wire				; trkkimise pointer
char_inp_2:		movlw	'A'
				movwf	bits					; seivitav smbol
char_inp_1:		call	wait_n_up
				movlw	OneWireByte				; seivimise aadress
				addwf	rombit_idx,W
				movwf	FSR
				movf	bits,W					; seivi smbol puhvrisse
				movwf	INDF
				movlw	.18						; rida 4 pos. 3 + pointer
				addwf	ctr_1wire,W
				movwf	dispX
				movlw	0x04
				call	goto_XY					; nime kirjutamise pos.
				movf	bits,W
				call	printcharext			; trki ekraanile
char_inp_3:		btfss	keypressed
				goto	char_inp_3
				movf	keypress,W
				sublw	nupp1
				btfsc	ZERO
				goto	char_inp_4				; keri thti vasakule
				movf	keypress,W
				sublw	nupp2
				btfsc	ZERO
				goto	char_inp_5				; keri thti paremale
				movf	keypress,W
				sublw	nupp3
				btfsc	ZERO
				goto	char_inp_6				; kustuta
				goto	char_inp_7				; sisesta/lpeta
char_inp_4:		movf	bits,W
				sublw	0x30
				btfsc	CARRY
				goto	char_inp_9				; juba alguses
				decf	bits,F	
				goto	char_inp_1;8
char_inp_5:		movf	bits,W
				sublw	0x60-.1
				btfss	CARRY
				goto	char_inp_9				; juba lpus
				incf	bits,F
				goto	char_inp_1;8
char_inp_6:		movf	rombit_idx,W			; nime alguses ei saa kustutada (tagasi minna)
				btfsc	ZERO
				goto	char_inp_9				; nii ongi
				decf	rombit_idx,F			; samm tagasi
				movlw	.6	
				subwf	ctr_1wire,F				; trkkimise samm tagasi ekraanil
				movlw	.18						
				addwf	ctr_1wire,W
				movwf	dispX
				movlw	0x04
				call	goto_XY					; vta see pos. sisse
				movlw	' '
				call	printcharext			; thik
				movlw	' '
				call	printcharext			; thik
				movlw	.18						
				addwf	ctr_1wire,W
				movwf	dispX
				movlw	0x04
				call	goto_XY					; vta see pos. sisse
				movlw	'A'
				movwf	bits					; default seivitav smbol
				goto	char_inp_1;8
char_inp_7:		incf	rombit_idx,F			; lpetame vi jrgmine pos. ?
				movf	rombit_idx,W			
				sublw	0x08
				btfsc	ZERO
				return							; 8 thte olemas, lpeta 
				movlw	.6
				addwf	ctr_1wire,F				; jrgmine pos.
				goto	char_inp_2
char_inp_9:		call	wait_n_up
				goto	char_inp_3
;===============================================================================
; Store_Bit vtab bitt A (bits.1) ja salvestab alasse work, offset rombit_idx
; bits.1 -> work0..work7(rombit_idx)
;===============================================================================
				org 0x200						; peab jma samale koodilehele !!!
Store_Bit:    movlw 	HIGH Store_Bit
			  movwf 	PCLATH
			  call      SetupFSR         		; converdi rombit_idx mlu aadressiks
              rrf       bits, W          		; loe bit.1 value right justified into W
              andlw     b'00000001'     		; lolle aadresse ei luba
              addwf     PCL, F           		; quick test for 0 or 1
              goto      ClrWorkBit       		; must be 0 (clr bit)
SetWorkBit                               		; must be 1 (set bit)
              clrc
              rlf       TEMP2, W         		; get bit position * 2 (0, 2, 4 .. 14)
              addwf     PCL, F           		; bump PC, turn bit on then return
              bsf       INDF, 7
              return
              bsf       INDF, 6
              return
              bsf       INDF, 5
              return
              bsf       INDF, 4
              return
              bsf       INDF, 3
              return
              bsf       INDF, 2
              return
              bsf       INDF, 1
              return
              bsf       INDF, 0
              return
ClrWorkBit
              clrc
              rlf       TEMP2, W         		; get bit position * 2 (0, 2, 4 .. 14)
              addwf     PCL, F           		; bump PC and turn it off then return
              bcf       INDF, 7
              return
              bcf       INDF, 6
              return
              bcf       INDF, 5
              return
              bcf       INDF, 4
              return
              bcf       INDF, 3
              return
              bcf       INDF, 2
              return
              bcf       INDF, 1
              return
              bcf       INDF, 0
              return
;===============================================================================
;GetWorkBit -- rk0..work7(rombit_idx) -> W
;===============================================================================
GetWorkBit:   movlw 	HIGH Store_Bit
			  movwf 	PCLATH
			  call      SetupFSR         		; viita soovitud bitile
              movlw     HIGH GetWorkBit
              movwf     PCLATH
              clrc
              rlf       TEMP2, W         		; get bit position * 2 into w
              addwf     TEMP2, W         		; compute w = bit offset * 3 (0, 3, 6 ...)
              addwf     PCL, F           		; bump PC to jump to appropriate test
;Bit 0
              btfss     INDF, 7          		; Is bit set(1)
               retlw    d'0'             		; No, return 0
              retlw     d'1'             		; Yes, return 1
;Bit 1
              btfss     INDF, 6         	 	; Is bit set(1)
               retlw    d'0'             		; No, return 0
              retlw     d'1'             		; Yes, return 1
;Bit 2
              btfss     INDF, 5          		; Is bit set(1)
               retlw    d'0'             		; No, return 0
              retlw     d'1'             		; Yes, return 1
;Bit 3
              btfss     INDF, 4          		;Is bit set(1)
               retlw    d'0'             		; No, return 0
              retlw     d'1'             		; Yes, return 1
;Bit 4
              btfss     INDF, 3          		;Is bit set(1)
               retlw    d'0'             		; No, return 0
              retlw     d'1'             		; Yes, return 1
;Bit 5
              btfss     INDF, 2          		;Is bit set(1)
               retlw    d'0'             		; No, return 0
              retlw     d'1'             		; Yes, return 1
;Bit 6
              btfss     INDF, 1          		;Is bit set(1)
               retlw    d'0'             		; No, return 0
              retlw     d'1'             		; Yes, return 1
;Bit 7
              btfss     INDF, 0          		; Is bit set(1)
               retlw    d'0'             		; No, return 0
              retlw     d'1'             		; Yes, return 1
;===============================================================================
; SetupFSR -- Point FSR at byte within work area determined by rombit_idx
;   Entry:
;         rombit_idx contians bit number (one relative) we need to get to
;   Exit:
;         FSR - pointing at byte within work0..work7
;         TEMP1 - zero relative byte offset (0,1,..7)
;         TEMP2 - zero relative(0,1,..7) bit offset within byte
;===============================================================================
SetupFSR:                                 		; Setup FSR, TEMP1(byte offset), and TEMP2(bit offset)
              decf      rombit_idx, W    		; convert index to 0 relative
              sublw     d'63'            		; form compliment of rombit_idw 0-63->63-0
              movwf     TEMP1            		; and temp byte offset area
              andlw     b'00000111'      		; strip off byte offset leaving bit offset only
              movwf     TEMP2            		; and save into temp bit offset area
              
              bcf		CARRY            		; right justify the byte offset in TEMP1
              rrf       TEMP1, F         		; by right shifting
              bcf		CARRY                   ; and stripping 3 LSB's 
              rrf       TEMP1, F
              bcf		CARRY
              rrf       TEMP1, F
;Get FSR pointing at appropriate byte in work area (work0, work1 ...)
              	movlw   work0	            	; FSR viitab nbi tala algusesse
              	movwf   FSR
              	movf    TEMP1,W            		; get byte offset (0 relative)
              	addwf   FSR, F           		; point FSR straight at it
              	return
;; *************************************************************************************************************
;; ************************ Loeb klaverit  *********************************************************************
;; *************************************************************************************************************
;klaver:			movf	PORTB,W
;				andlw	0xF0					; kustutame tarbetud LCD bitid
;				movwf	keypress1				; vajutatud ?
;				sublw	0xF0
;				btfss	ZERO
;				goto	n1_down
;				movf	n1timer,W				; lahti lastud
;				sublw	ndebounce
;				btfsc	CARRY					
;				goto	n1_err					; hire
;				bsf		keypressed				; mingi vajutus, vaatab kui pikk tpselt.
;				movf	n1timer,W
;				sublw	nshort
;				btfss	CARRY
;				goto	n1_end1					; pikk vajutus oli!
;				goto	n1_err					; lhikese vajutuse lpp
;n1_end1:		bsf		longpress				; pikk vajutus oli!
;n1_err:			clrf	n1timer					; liiga lhike vajutus (hire), unustame 
;				return
;				goto	n1_err
;n1_down:		movf	keypress1,W				; seivi klahvi kood
;				movwf	keypress
;				movf	n1timer,W				; le re ei lase
;				sublw	0xFF
;				btfsc	ZERO
;				return
;				incf	n1timer,F				; vajutatud, suurendame loendit
;				return
;===============================================================================
; ******* viited *******
;===============================================================================
;wait:			movlw	0xFF
;wait_x:			bsf		pank
;				movwf	PR2
;				bcf		pank
;				clrf	TMR2
;				bsf		T2CON,TMR2ON
;				bcf		PIR1,TMR2IF
;wait_1:			btfss	PIR1,TMR2IF
;				goto	wait_1
;				bcf		T2CON,TMR2ON
;				bcf		PIR1,TMR2IF
;				return
; ***** 20 usec *****  
wait:			movlw	0xFF;0x0C
wait_x:			movwf   t_count 
				goto	W60u_Loop
;; ***** 60 usec *****  
;Wait_60us         
;				movlw   0x20
;				movwf   t_count 
W60u_Loop         
				decfsz  t_count,F          
				goto W60u_Loop              
				return  
; *************************************************************************************************************
; *************************************** 10 msec *************************************************************
; *************************************************************************************************************
Wait_2ms:       movlw	0x0D
				movwf	t1_count 
wait_1:			clrf   	t_count 
wait_2:			decfsz  t_count,1   			; +1         
				goto 	wait_2
				decfsz	t1_count
				goto	wait_1         
				return    
; *************************************************************************************************************
; ********************** I-nbi lugejaga suhtlemise funktsioonid *********************************************
; *************************************************************************************************************
; *************************************************************************************************************
; ********************** saadab lugejale nbi koodi **********************************************************
; *************************************************************************************************************
Tx_1wire:;		call    Ibut_init				; nbi muutujatele saabast
				bcf 	RdrDetect              	; resetti pole veel kinni ptud!
				bcf		viga
				movlw	UserTimeH				; lae ldise ooteaja taimer (30 sekundit)
				movwf	UserTimerH
				movlw	UserTimeL				
				movwf	UserTimerL
				bcf		UserTimeOut
				bsf		UserTimerOn				; taimer kima
;				bcf		INTCON,INTF				; lugeja pole veel sna vtnud
				call	rdr_reset				; oota lugeja reset-signaal
				btfsc	viga					; kik Oki_Doki?
				return							; viga oli, vlssivad raiped
				bcf		UserTimeOut
				bcf		UserTimerOn				; 30 sekundi taimer stopp
				clrf	TMR0					; nd saab minna kuni 32 ms
				bcf		INTCON,T0IF	
				bcf		INTCON,GIE			
				call	read_byte1w				; loe ksk. Peaks olema 0xF0 (search ROM)
				btfsc	viga					; kik Oki_Doki?
;				return							; viga oli, vlssivad raiped
				goto	Tx_1wire_4a				; teata veast
				movf	OneWireByte,W
				sublw	0xF0					; on siis Search Rom?
				btfsc	ZERO
				goto	Tx_1wire_1				; oli, tegutseb edasi
				bsf		viga					; midagi muud...
;				return
				goto	Tx_1wire_4b				; teata veast
Tx_1wire_1:		movlw	IbaitCount				; lae tskli loendid
				movwf	tempone
				movlw	IbitCount-.1
				movwf	temptwo
Tx_1wire_2:		movf	tempone,W 				; arvuta jooxva biti lugemiseks vajaliku registri aadress
;				sublw	IbaitCount
				addlw	work0-.1
				movwf	FSR						; loeme sealt kaudselt
Tx_1wire_2a:	bcf		CARRY
				bcf		TEMP1,.0				; oletame, et oli vaja nulli
				rrf		INDF,F					; nihuta bitt registrist CY-sse
				btfsc	CARRY
				bsf		TEMP1,.0				; saime he
				call	write_bit1w				; saada fonolukule
				btfsc	viga
;				return							; tuksi lx
				goto	Tx_1wire_4c				; teata veast

				movf	temptwo,W				; 8 bitti tehtud?
				btfsc	ZERO
				goto	Tx_1wire_3				; jah, lae uuesti
				decf	temptwo,F				; ei, vhenda
				goto	Tx_1wire_2a				; ja jtka

Tx_1wire_3:		movlw	IbitCount-.1			; taasta bittide count baidis
				movwf	temptwo
				decfsz	tempone					; kik saadetud
				goto	Tx_1wire_2				; lase edasi...
				return							; valmis
Tx_1wire_4a:	movlw	'1'
				call	send_dat
				goto	Tx_1wire_4
Tx_1wire_4b:	movlw	'2'
				call	send_dat
				goto	Tx_1wire_4
Tx_1wire_4c:	movlw	'3'
				call	send_dat
				goto	Tx_1wire_4
Tx_1wire_4:;	bcf LED
		movlw	0x00					; rida 6 pos. 0
				movwf	dispX
				movlw	LOW mess_4-LOW mess_0	; kirje 4 "Side viga" 
				movwf	Messi_nr
				movlw	0x05
				call	print_msg_XY
	bsf	INTCON,GIE			
				call	mainos_0	
				return
;===============================================================================
; ** saadab biti ja tema prdvrtuse TEMP1.0-st I-nbi lugejasse (fonolukk)**
;===============================================================================
write_bit1w:	bcf		INTCON,INTF				; lugeja takti pulssi veel pole
write_bit1w_1:	btfsc	INTCON,INTF				; ootame langevat fronti
				goto	write_bit1w_2			; tuli!
				btfss	INTCON,T0IF				; aega on veel ?
				goto	write_bit1w_1			; jah!
write_bit1w_x:	bcf		INTCON,T0IF				; sai siiber ootamisest
				bsf		viga
				return
write_bit1w_2:	bcf		INTCON,INTF				; katckestus maha
				bsf 	Fbut	               	; lugeja otc krgex
				bsf		pank
				bcf		Tris_Fbutton			; ja vljundiks
				bcf		pank
				btfss	TEMP1,.0
				goto	write_bit1w_2a
				bsf		Fbut					; oli vaja saata ks
				goto	write_bit1w_2b
write_bit1w_2a:	bcf 	Fbut					; oli vaja saata null
write_bit1w_2b:	movlw	0x04;2					; oota 19;5 uS
				call	wait_x
				bsf 	Fbut	               	; lugeja otc krgex
				bsf		pank
				bsf		Tris_Fbutton			; ja sisendiks
				bcf		pank
				bcf		INTCON,INTF
; saadab sama biti inversioonvrtuse
write_bit1w_3:	btfsc	INTCON,INTF				; ootame langevat fronti
				goto	write_bit1w_4			; tuli!
				btfss	INTCON,T0IF				; aega on veel ?
				goto	write_bit1w_3			; jah!
				goto	write_bit1w_x			; persses...
write_bit1w_4:	bcf		INTCON,INTF				; katckestus maha
				bsf 	Fbut	               	; lugeja otc krgex
				bsf		pank
				bcf		Tris_Fbutton			; ja vljundiks
				bcf		pank
				btfss	TEMP1,.0
				goto	write_bit1w_4a
				bcf		Fbut					; oli vaja saata null (inversioon)
				goto	write_bit1w_4b
write_bit1w_4a:	bsf 	Fbut					; oli vaja saata ks (inversioon)
write_bit1w_4b:	movlw	0x04;2					; oota 19;5 uS
				call	wait_x
; loeme peremehe vastusbiti (mida tema sooviks nha)
				bsf 	Fbut	               	; lugeja otc krgex
				bsf		pank
				bsf		Tris_Fbutton			; ja sisendiks
				bcf		pank
				bcf		INTCON,INTF
				call	read_bit1w				; loe vastus
;				btfsc	CARRY					; ja vrdle saadetuga
;				goto	write_bit1w_5
;				btfss	TEMP1,.0
;				return							; vrdsed
;				goto	write_bit1w_x			; erinevad!
;write_bit1w_5:	btfsc	TEMP1,.0
              	return 							; vrdsed
				goto	write_bit1w_x			; erinevad!
;===============================================================================
; ******* loeb baidi I-nbi lugejast (fonolukk) registrisse OneWireByte *******
;===============================================================================
read_byte1w:	clrf	OneWireByte
				bcf		viga
				movlw   .8						; bittide loendi
	            movwf   TEMP0
				bcf		INTCON,INTF				; pulssi veel pole
read_byte1w_l:  call    read_bit1w
				btfsc	viga					; lks liiga kaua ?
				return
              	rrf     OneWireByte,F   		; nihuta bitt tulemuse registrisse
	            decfsz  TEMP0,F		 	        ; 8 bitti OK?
               	goto    read_byte1w_l     		; vara veel
              	movf    OneWireByte,W		    ; jah, tulemus W-sse
             	return 
;===============================================================================
; ******************* loeb BITI I-nbi lugejast (fonolukk) ********************
;===============================================================================
read_bit1w:	;	bcf    	Ibut	         		; nbi taktipulss - madalax
;				bcf		INTCON,INTF				; pulssi veel pole
read_bit1w_1:	btfsc	INTCON,INTF				; ootame langevat fronti
				goto	read_bit1w_2			; tuli!
				btfss	INTCON,T0IF				; aega on veel ?
				goto	read_bit1w_1			; jah!
read_bit1w_x:	bcf		INTCON,T0IF				; sai siiber ootamisest
				bsf		viga
				return
read_bit1w_2:	bcf		INTCON,INTF				; katckestus maha
				movlw	0x04;8					; oota 30 uS
				call	wait_x
				bcf		CARRY					; oletame, et saime 0-i
				btfsc	Fbut
				bsf		CARRY					; oli aga 1
				return
; *************************************************************************************************************
; ********************** nbile reseti ootamine **************************************************************
; *************************************************************************************************************
rdr_reset:		bcf		INTCON,INTF				; lugeja pole veel sna vtnud
				bcf		viga
rdr_res_1:		btfsc	INTCON,INTF				; ootame langevat fronti
				goto	rdr_res_2				; tuli!
				btfss	UserTimeOut				; aega on veel ?
				goto	rdr_res_1				; jah!
rdr_res_x:		bcf		UserTimerOn				; sai siiber ootamisest
				bcf		UserTimeOut	
				bsf		viga
				movlw	0x00					; rida 6 pos. 0
				movwf	dispX
				movlw	LOW mess_3-LOW mess_0	; kirje 3 "Liiga kaua" 
				movwf	Messi_nr
				movlw	0x05
				call	print_msg_XY
				call	mainos_0	
				return
rdr_res_2:		bcf		INTCON,INTF
				movlw	0x9A					; oota 469 uS
				call	wait_x
				btfsc	Fbut					; lugeja saadab resetti (otc madal)?
				goto	rdr_res_x				; ei -> mndunegi viga
rdr_res_3:		btfsc	Fbut					; ootab kuni reseti otc taas krge 
				goto	rdr_res_4				; ongi, vastame
				btfss	UserTimeOut				; aega on veel ?
				goto	rdr_res_3				; jah!
				goto	rdr_res_x				; ei -> mndunegi viga
rdr_res_4:		bsf		pank
				bcf		Tris_Fbutton			; lugeja otc vljundiks
				bcf		pank
				bcf 	Fbut	               	; ja madalax
				movlw	0x4A					; oota 230 uS
				call	wait_x
				bsf		pank
				bsf		Tris_Fbutton			; sisendiks
				bcf		pank
	            bsf 	Fbut	                ; ja krgex tagasi
				bsf 	RdrDetect              	; resett kinni ptud!
				return
; *************************************************************************************************************
; ************************ Nokia LCD rutiinid *****************************************************************
; *************************************************************************************************************
; *************************************************************************************************************
; ************************************* saada Data displeile **************************************************
; *************************************************************************************************************
Send_DATA   	movwf	lcdtmp 					; seivi daata 
				movlw	0x08					; 8 bitti saata
				movwf	LCD_Count
;				bsf		NokReset
				bcf		NokCS
				bsf		NokD_C
				bcf		NokDat
				bcf		NokClk
send_d_1:		rlf		lcdtmp,F				; nihutame saadetava biti CY-sse
				bsf		NokDat					; arvutame LCD-le saadetava daatabiti vrtuse
				btfss	CARRY	
				bcf		NokDat
				nop
				bsf		NokClk					; teeme taktiotsaga jonksu
				nop
				bcf		NokClk					; takt nulli tagasi
				nop
				decfsz	LCD_Count				; nii 8 korda
				goto	send_d_1
				bsf		NokCS					; deselektime displei
				nop
				return  
; *************************************************************************************************************
; ********************************** saada ksk displeile *****************************************************
; *************************************************************************************************************
Send_CMD:	  	movwf	lcdtmp 					; seivi ksk 
				movlw	0x08					; 8 bitti saata
				movwf	LCD_Count
;				bsf		NokReset
				bcf		NokCS
				bcf		NokD_C
				bcf		NokDat
				bcf		NokClk
				goto	send_d_1				; jtkame nagu daata saatmise puhul
				return  
; *************************************************************************************************************
; ********************************************* lhtesta displei **********************************************
; *************************************************************************************************************
Init_LCD:;		bsf		NokReset				; Reset aktiivseks
				bsf		NokCS
				bsf		NokD_C
				bcf		NokDat
				bcf		NokClk
;			    call    Wait_2ms        		; ootame 10 mS       
;				bcf		NokReset				; reset maha
				movlw	0x21					; ksk
				call	Send_CMD
				movlw	0xC2					; ksk
				call	Send_CMD
				movlw	0x13					; ksk
				call	Send_CMD
				movlw	0x20					; ksk
				call	Send_CMD
				movlw	0x09					; ksk
				call	Send_CMD
				call	clr_scr					; LCD ajupesu
				movlw	0x08					; ksk
				call	Send_CMD
				movlw	0x0C					; ksk
				call	Send_CMD
				return  
; *************************************************************************************************************
; ********************************************* goto X,Y (dispX, DispY), W-s peab olema Y-pos! ****************
; *************************************************************************************************************
goto_XY:		movwf	dispY
				movf	dispY,W					; loevad vaid 3 nooremat bitti
				andlw	0x07
				addlw	0x40
				call	Send_CMD
				bsf		dispX,7					; vanima biti keerame hte
				movf	dispX,W
				call	Send_CMD
				return  
; *************************************************************************************************************
; ********************************** LCD mlu pesu  ***********************************************************
; *************************************************************************************************************
clr_scr:		clrf	dispX					; alates 0,0 -st
				clrf	dispY
				clrw
				call	goto_XY
				movlw	.6						; 6 rida (a 8a pixelit)
				movwf	dispY
Clear_1:		movlw	.84						; 84 pixelit
				movwf	dispX
Clear_2:		clrw	
				call	Send_DATA
				decfsz	dispX
				goto	Clear_2
				decfsz	dispY
				goto	Clear_1
				return
; *************************************************************************************************************
; ********************************** Avaekraan ja  reklaam **************************************************** 
; *************************************************************************************************************
mainos:			movlw	.12						; rida 0 pos. 2
				movwf	dispX
				movlw	LOW mess_0-LOW mess_0	; kirje 0 "I-mrkmik."
				movwf	Messi_nr
				clrw
				bsf		invtxt					; tekst inversioonis
				call	print_msg_XY			; saada reklaamtekst skriinile

				call	Mem_free				; leia vaba mlu maht
				movf	TEMP1,W
				btfss	ZERO
				goto	mainos_1				; ei ole veel tis
				movlw	.12						; mlu tis, kirjuta seda reale 4 pos. 2
				movwf	dispX
				movlw	LOW mess_6-LOW mess_0	; kirje 6 "Mlu tis" 
				movwf	Messi_nr
				movlw	0x03
				bsf		invtxt					; tekst inversioonis
				call	print_msg_XY
				goto	mainos_3	


mainos_1:		movf	TEMP1,W					; kki thi ?
				sublw	maxentries
				btfss	ZERO
				goto	mainos_2				; ei ole thi
				movlw	.12						; mlu thi, kirjuta seda reale 4 pos. 2
				movwf	dispX
				movlw	LOW mess_7-LOW mess_0	; kirje 7 "Mlu thi" 
				movwf	Messi_nr
				movlw	0x03
				bsf		invtxt					; tekst inversioonis
				call	print_msg_XY
				goto	mainos_3	

mainos_2:		movlw	0x00					; rida 4 pos. 0
				movwf	dispX
				movlw	LOW mess_5-LOW mess_0	; kirje 5 "Mlus x vaba numbr." 
				movwf	Messi_nr
				movlw	0x03
				call	print_msg_XY	

				movlw	.36						; rida 4 pos. 7
				movwf	dispX
				movlw	0x03
				call	goto_XY					; kirjuta vabade kohtade arv
				movf	freemem,W
				sublw	maxentries
				call	HEX2LCD


mainos_3:		movlw	0x18					; rida 6 pos. 4
				movwf	dispX
				movlw	LOW mess_1-LOW mess_0	; kirje 1 "Felch 2005" 
				movwf	Messi_nr
				movlw	0x05
				bsf		invtxt					; tekst inversioonis
				call	print_msg_XY	
		
mainos_0:		clrf	tmp
mainos4:		call    Wait_2ms  				; oota veidi   
				decfsz	tmp
				goto	mainos4
;				call	clr_scr
				return
; *************************************************************************************************************
; **************************************** Tekraan **********************************************************
; *************************************************************************************************************
maindisp:		call	clr_scr
				movlw	.12						; rida 0 pos. 2
				movwf	dispX
				movlw	LOW mess_0-LOW mess_0	; kirje 0 "I-mrkmik."
				movwf	Messi_nr
				clrw
				bsf		invtxt					; tekst inversioonis
				call	print_msg_XY			; saada reklaamtekst skriinile

				call	Mem_free				; leia vaba mlu maht
				movlw	.30						; rida 2 pos. 5
				movwf	dispX
				movlw	LOW mess_8-LOW mess_0	; kirje 8 " kirjet" 
				movwf	Messi_nr
				movlw	0x02
				call	print_msg_XY
				movlw	.12						; rida 2 pos. 2
				movwf	dispX
				movlw	0x02
				call	goto_XY
				movf	freemem,W
				sublw	maxentries
				call	HEX2LCD
				
				movlw	.0						; rida 5 pos. 0
				movwf	dispX
				movlw	LOW mess_9-LOW mess_0	; kirje 9 - men "RD"
				movwf	Messi_nr
				movlw	0x05
				bsf		invtxt					; tekst inversioonis
				call	print_msg_XY

				movf	freemem,W				; kui mlu thi, ei trki kirjeid Snd ja Del
				sublw	maxentries
				btfss	ZERO
				goto	maindisp_2				; ei ole thi
maindisp_1:		movf	freemem,W				; kui mlu tis, ei trki kirjet New
				btfsc	ZERO
				return
				movlw	.66						; rida 5 pos. 11
				movwf	dispX
				movlw	LOW mess_16-LOW mess_0	; kirje 16 - men "New"
				movwf	Messi_nr
				movlw	0x05
				bsf		invtxt					; tekst inversioonis
				call	print_msg_XY
				return
maindisp_2:		movlw	.18						; rida 5 pos. 3
				movwf	dispX
				movlw	LOW mess_15-LOW mess_0	; kirje 15 - men "Snd Del"
				movwf	Messi_nr
				movlw	0x05
				bsf		invtxt					; tekst inversioonis
				call	print_msg_XY
				goto	maindisp_1				; vaata, kas "New" ka trkkida vi mitte
; *************************************************************************************************************
; ********************* saadab HEX (BCD)baidi registrist W LCD-skriinile **************************************
; *************************************************************************************************************
HEX2LCD:   		movwf   temphex2lcd         
				swapf   temphex2lcd,W         
				call    Nibble2ASCII 
				addlw	0x10					; teisendame meie thestiku numbrikoodiks      
				call    printchar    			; LCD-le    
				movf    temphex2lcd,W         
HEX2LCD1:		call    Nibble2ASCII         
				addlw	0x10					; teisendame meie thestiku numbrikoodiks      
				call    printchar    			; LCD-le    
				return  
; ***** Convert Nibble to ASCII Hex Digit *****  
Nibble2ASCII         
				andlw   h'0F'         
				addlw   h'F6'         
				btfsc   CARRY         
				addlw   h'07'         
				addlw   h'0A'         
				return  
; *************************************************************************************************************
; ************************************* saada kiri displeile kohta dispX,dsipY ********************************
; *************************************************************************************************************
; *************************************************************************************************************
print_msg_XY:	call	goto_XY					; saada koordinaadid
; *************************************************************************************************************
; ************************************* saada kiri flashist displeile *****************************************
; *************************************************************************************************************
print_msg:		movf	Messi_nr,W				; saa messi algusaadress
print_msg_1:	movf	PCLATH,W
				movwf	Lath_tmp       
				movf	Messi_nr,W
				call	Mes_tabel				; loe kirje bait 
				movwf	tmp						; seivi sest lahutamine rikub leitud baidi
				movf	Lath_tmp,W
				movwf	PCLATH
				movf	tmp,W
				sublw	0xFF					; lpu smbol?
				btfsc	ZERO
				goto	print_msg_2				; lpp, vta inversioon maha!
				movlw	0x20
				subwf	tmp,W					; tabel algab alles thikust, selle kood maha
				call	printchar				; tabloole
				incf	Messi_nr,F				; jrgmine smbol
				goto	print_msg_1				; pointer ees tsklisse ;)
print_msg_2:	bcf		invtxt
				return							; lpp!
; *************************************************************************************************************
; ************************************* saada kiri RAMist displeile *******************************************
; *************************************************************************************************************
print_msg_ram:	movwf	FSR						; messi algusaadress
print_msg_r1:	movf	INDF,W					; loe smbol
				sublw	0x0D					; lpp ?
				btfsc	ZERO
				return							; jah
				movf	INDF,W					; taasta smbol
				incf	FSR,F					; viitaa jrgmisele
				call	printcharext			; ekraanile
				goto	print_msg_r1			; pointer ees tsklisse ;)
; *************************************************************************************************************
; ************************************* saada smbol displeile ************************************************
; *************************************************************************************************************
printcharext:	movwf	tmp						; thtede trkimine mitte oma tabelitest - lahuta offset!
				movlw	0x20
				subwf	tmp,W
printchar:		movwf	Table_Temp				; ajutine seiv
				movlw	0x63					; kas tht, mida tunneme (tablelis olemas)?
				subwf	Table_Temp,W
				btfsc	CARRY
				goto	print_replace
printc_00:		clrf	Table_hitmp
				movlw	0x05					; tabelist on vaja lugeda 5 baiti
				movwf	dispX					; ajutine pointer
				movf	Table_Temp,W			; seivi
				btfsc	ZERO					; kui 0 (thik), siis hookus-pookust ei tee
				goto	printc_3
				movwf	tmp
				clrw							; korrutame aadressi 5-ga sest sbolid koosnevad 5-st baidist
printc_2:		bcf		CARRY
				addlw	0x05
				btfsc	CARRY
				incf	Table_hitmp				; letitumine: korrigeerib tabeli krgemat aadressi	
				decfsz	tmp
				goto	printc_2
				movwf	Table_Temp				; tulemus seivida
printc_3:		movlw	HIGH Nok_tabel			; tabeli HIGH aadress leida ja seivida
				addwf	Table_hitmp,F

printc_1:		movf	PCLATH,W
				movwf	Lath_tmp
				call	Nok_tabel				; vtab tabelist baidi...
				movwf	msg_tmp
				movf	Lath_tmp,W
				movwf	PCLATH
				movf	msg_tmp,W
				btfsc	invtxt					; inversioonis ?
				comf	msg_tmp,W
				call	Send_DATA				; ja saadab displeile
				bcf		CARRY
				movlw	0x01
				addwf	Table_Temp,F
				btfsc	CARRY
				incf	Table_hitmp,F
				decfsz	dispX			
				goto	printc_1				; kuni kik 5 tk olemas
				clrw							; lppu saadame 0x00 (2 smboli vaheline thi ala)
				btfsc	invtxt					; inversioonis ?
				movlw	0xFF
				call	Send_DATA				; displeile
				return
print_replace:	movlw	0x1F					; smbol "?"
				movwf	Table_Temp
				goto	printc_00
;===============================================================================
; ***** Saada nbi number (work0...8) ekraanile *****  
;===============================================================================
print_but:		movlw	work0
				movwf	FSR
				movlw	.8
				movwf	t_count
print_but1:		movf	INDF,W
				call	HEX2LCD
				incf	FSR,F
				decfsz	t_count
				goto	print_but1
				return
;===============================================================================
; ******* RS232-e rutiinid *******
;===============================================================================
; ***** Saada nbi number (work0...8) serialporti *****  
;===============================================================================
send_but:		movlw	work0
				movwf	FSR
				movlw	.8
				movwf	t_count
send_but1:		movf	INDF,W
				call	send_dat
				incf	FSR,F
				decfsz	t_count
				goto	send_but1
				return
;===============================================================================
; ************************* saadame baidi seriali ******************************
;===============================================================================
send_dat:
snd_cmd_busy	btfss   PIR1,TXIF     			; saatja valmis ?   
			    goto    snd_cmd_busy
    			movwf   TXREG    				; saada!
snd_exit:		btfss   PIR1,TXIF     			; saatja valmis ?   
			    goto    snd_exit
				bsf		STATUS,RP0
snd_exit1:		btfss	TXSTA,TRMT				; kas saatja nihkeregister thi (bait prosest vljas)?
				goto	snd_exit1
				bcf		STATUS,RP0
				movf	RCREG,W					; thjenda RCREG
				bcf		RCSTA,CREN				; nullime pordi
				bsf		RCSTA,CREN
			    return
;;===============================================================================
; ******* initsialiseerimine *******
;===============================================================================
init			clrf	STATUS					;
				clrf	PORTA					; 
				clrf	PORTB					;
				clrf	TMR1L
				clrf	TMR1H
;				clrf	TMR2
;-------------------------------
				movlw	B'00000111'				; komparaatorid OFF
				movwf	CMCON					
				bsf		STATUS,RP0				; Pank 1
				movlw	B'00000000'				; tugipinge OFF
				movwf	VRCON					
;-------------------------------
				movlw   B'00110001'				; LCD otsad ja np vljundiks, muud sisendiks
    			movwf	TRISA					; 
				movlw   B'11110111'				; kik peale LEDi sisendid
    			movwf	TRISB					; 
;-------------------------------
;				movlw   b'00000000'         
;				movwf   OPTION_REG      		; 1:1 prescaler T0-le, sisemine takt, WPU lubatud 
				movlw	B'00000111'				; WPU-d sisse,  prescaler 1:128, T0 jaoks , RB0 int langeval frondil
				movwf	OPTION_REG				
;				movlw	B'00100001'		 		; luba vaid ser. receive, ja T1 intsid
				movlw	B'00000001'		 		; luba vaid ser. receive, ja T1 intsid
				movwf	PIE1
				bcf		STATUS,RP0				; Pank 0		
;-------------------------------
				movlw	B'11110110'
    			movwf	PORTB					; kik otcad krgex, DIR ja  madalad
				movlw	B'11100111'
    			movwf	PORTA					; kik otcad krgex,  madal
;------------------------------- 				; USARTi hlestus
				bsf		STATUS,RP0				; Pank 1		
				movlw	.25						; baudrate = 9600
				movwf	SPBRG		
				movlw	B'01100111'				; 1 bitine saade
				movwf	TXSTA
				bcf		STATUS,RP0
				movlw	B'10010000'				; 8-bitine vv, ADEN keelatud
				movwf	RCSTA
;------------------------------- 
				movlw	B'00010000'				; katskestusi ei ole esinenud, RS232 porti ei puudu: read-only
				movwf	PIR1	
;				movlw	B'01001000'				; Perifeeria intsid lubada, (RB ka, katckestust ei ole olnud!), GIE keelata esialgu
				movlw	B'01000000'				; Perifeeria intsid lubada, (RB ka, katckestust ei ole olnud!), GIE keelata esialgu
				movwf	INTCON
;-------------------------------				; katkestused lubada
;blnk			movlw	0x03				
;				call	blink_W					; vilguta tuld 3*
;;-------------------------------				; katkestused lubada
;blnk:			movf	PORTB,W					; loeme sisendite seisu et sisendite katckestuse net eirata
;				bcf		INTCON,RBIF				; katkestuse nue maha
;				btfss	N_up					; ootame nuppude otste krgeks minekut
;				goto	blnk
;				btfss	N_left
;				goto	blnk
;				btfss	N_right
;				goto	blnk
;				btfss	N_down
;				goto	blnk
;-------------------------------				; muu pudi
				movlw	Puhver
				movwf	RxPointer				; vastuvtupuhvri pointer
				clrf	bytecnt					; vastuvetud baitide loendi
				clrf	Flags					; libud pikali
				clrf	Flags1
				movlw	rdrtime					; lukuga suhtlemise taimer
				movwf	rdrtimer
				movlw	serialtime
				movwf	serialtimer
				movlw	keytime
				movwf	keytimer
;-------------------------------				; lae ssteemi phitaimer
				movlw	T1resoL					; lae taimer 1 (katkestus iga 10 mS tagant)
				movwf	TMR1L
				movlw	T1resoH
				movwf	TMR1H
				movlw	B'00000000'
				movwf	T1CON					; 1:1 prescaler, taimerina, stopp !
;-------------------------------				; lubame intsid - ssteem tx valmis
				movf	PORTB,W					; loeme sisendite seisu et sisendite katckestuse net eirata
				bcf		INTCON,RBIF				; katkestuse nue maha
;				movlw	B'11001000'				; GIE, PEIE ja RBIE lubada!
				movlw	B'11000000'				; GIE, PEIE ja RBIE lubada!
				movwf	INTCON
				return
;===============================================================================
;************* kontrollib kas loetud np on juba mlus olemas *****************
;===============================================================================
check:			bcf		already					; oletame, et ei ole veel sellist
			 	movlw	num1					; esimese numbri koht EEPROMis
				movwf	TEMP0
check_0:		movlw	work0					; vrreldav daata
				movwf	FSR					
				movlw	IbaitCount				; kirje pikkus
				movwf	TEMP2
check_1:		movf	TEMP0,W					; aadress
				sublw	maxentries*.16			; kik lbi kidud ?
				btfsc	ZERO
				return							; jah, ei leitud mtchi ;)
				movf	TEMP0,W					; lase aga edasi
				call	riid					; loe bait EEPROMist
				subwf	INDF,W
				btfss	ZERO					; vrdsed ?
				goto	check_2					; ei
				incf	TEMP0,F					; ja...vaatame edasi (source)
				incf	FSR,F					; destination
				decfsz	TEMP2					; kogu kirje lbi vaadatud?
				goto	check_1					; ei veel
				bsf		already					; jah, seda numbrit me juba teame
				return
check_2:		incf	TEMP0,F					; jrgmine mluaadress (ei viitsi jrgmise kirje algust vlja raalida :(  )
				goto	check_0					; ja jtka
;===============================================================================
;**** Loeb  kokku kasutatud EEPROM-mlu mahu ja leiab esimese vaba pesa adre ***
;===============================================================================
Mem_free:		movlw	maxentries				; niipaljukest kirjeid olla saab
				movwf	TEMP2
			 	movlw	num1					; esimese numbri koht EEPROMis
				movwf	TEMP0
				clrf	TEMP1					; loendamise tulemus
mem_fr_1:		movf	TEMP0,W					; aadress
				call	riid					; loe
				btfss	ZERO
				goto	mem_fr_3
				incf	TEMP1,F					; 1 vaba koht leitud
				btfsc	viga					; esimene vaba juba leitud ?
				goto	mem_fr_3
				movf	TEMP0,W					; seivi tema aadress
				movwf	firstfree
				bsf		viga					; leidsime vaba koha, enam firstfree'd ei muuda
mem_fr_3:		decfsz	TEMP2					; kik ?
				goto	mem_fr_2				; ei veel
				movf	TEMP1,W					; seivi vabade kohtade arv
				movwf	freemem
				bcf		viga
				return
mem_fr_2:		movlw	.16						; vtame jrgmise kirje aadressi
				addwf	TEMP0,F
				goto	mem_fr_1
;===============================================================================
;****************** kirjutab daatabloki EEPROMisse *****************************
;===============================================================================
writed:			bsf		pank
				movwf	EEDATA
				bcf		pank
				movf	t1_count,W
write:			bcf		INTCON,GIE
				bsf		pank
				movwf	EEADR
				bsf		EECON1,WREN				
				movlw	55h						
				movwf	EECON2
				movlw	0AAh
				movwf	EECON2
				bsf		EECON1,WR					
write_1:		btfsc	EECON1,WR 				
				goto	write_1
				bcf		EECON1,WREN		
				bcf     pank
				bsf		INTCON,GIE
				return
;===============================================================================
;* Loeb luku baidi EEPROMist 
;===============================================================================
riid:			bsf     pank
				movwf	EEADR	
				bsf		EECON1,RD			 	; loe!
				movf	EEDATA,W
				bcf     pank
				return
; *************************************************************************************************************
; ************************ Mitmesegased messid ja mend ******************************************************
; *************************************************************************************************************
				org     h'0510'  
Mes_tabel:		movwf   Table_Temp  
				movlw   h'05'         
				movwf   PCLATH   
				movlw	LOW mess_0				
				addwf	Table_Temp,W
				btfsc	CARRY      
				incf	PCLATH
				movwf	PCL  															; vali sobiv mess vastavalt numbrile (vt. allpool)

mess_0:			dt      'I','-','m',0x7C,'r','k','m','i','k','.',0xFF					; mess 0, "I-mrkmik."
mess_1:			dt      'F','e','l','c','h',' ','2','0','0','6',0xFF					; mess 1, "Felch 2006"
mess_2:			dt      'N',0x7D,0x7D,'b','i',' ','d','a','t','a',0xFF					; mess 2, "Nbi data"
mess_3:			dt      'L','i','i','g','a',' ','k','a','u','a',' ',' ',' ',' ',0xFF	; mess 3, "Liiga kaua"
mess_4:			dt      'S','i','d','e',' ','v','i','g','a',' ',' ',' ',' ',' ',0xFF	; mess 4, "Side viga"
mess_5:			dt      'M',0x7C,'l','u','s',' ',' ',' ','n','u','m','b','r','.',0xFF	; mess 5, "Mlus   numbr." (pos.7)
mess_6:			dt      'M',0x7C,'l','u',' ','t',0x7C,'i','s','!',0xFF					; mess 6, "Mlu tis!"
mess_7:			dt      'M',0x7C,'l','u',' ','t',0x7E,'h','i','!',0xFF					; mess 7, "Mlu thi!"
mess_8:			dt      ' ','k','i','r','j','e','t',0xFF								; mess 8, "n kirjet"
;mess_9:			dt      'R','D',' ','S','n','d',' ','D','e','l',' ','N','e','w',0xFF	; mess 9, men
mess_9:			dt      'R','D',' ',0xFF												; mess 9, men -> "RD "
mess_10:		dt      'S','i','s','e','s','t','a',' ','I','-','n',0x7D,0x7D,'p',0xFF	; mess 10, "Sisesta I-np"
mess_11:		dt      'S','a','v','e',0xFF											; mess 11, "Save"
mess_12:		dt      'E','S','C',0xFF												; mess 12, "ESC"
mess_13:		dt      'J','u','b','a',' ','o','l','e','m','a','s','!',0xFF			; mess 13, "Juba olemas!"
mess_14:		dt      ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',0xFF	; mess 14, thikud
mess_15:		dt      'S','n','d',' ','D','e','l',' ',0xFF							; mess 15, men -> "Snd Del "
mess_16:		dt      'N','e','w',0xFF												; mess 16, men -> "New"
mess_17:		dt      ' ',0x7F,' ',' ',0x80,' ',' ',' ','X',' ',' ',' ',0x81,' ',0xFF	; mess 17, men
; *************************************************************************************************************
; ************************ Nokia LCD thestik *****************************************************************
; *************************************************************************************************************
;**** Nokia LCD thegeneraatori tabel ****
				org     h'0600'  
Nok_tabel:		movf	Table_hitmp,W       
				movwf   PCLATH         
  
				movlw	LOW Nok_tabel_1				
				addwf	Table_Temp,W
				btfsc	CARRY      
				incf	PCLATH,F
				movwf	PCL  						; vali sobiv thekuju
Nok_tabel_1:	dt		0x00,0x00,0x00,0x00,0x00	; 20 space	
				dt		0x00,0x00,0x5F,0x00,0x00	; 21 !
				dt		0x00,0x07,0x00,0x07,0x00	; 22 "
				dt		0x14,0x7f,0x14,0x7f,0x14	; 23 #
				dt		0x24,0x2a,0x7f,0x2a,0x12	; 24 $
				dt		0x23,0x13,0x08,0x64,0x62	; 25 %  (1)
				dt		0x36,0x49,0x55,0x22,0x50	; 26 &
				dt		0x00,0x05,0x03,0x00,0x00	; 27 '
				dt		0x00,0x1c,0x22,0x41,0x00	; 28 (
				dt		0x00,0x41,0x22,0x1c,0x00	; 29 )
				dt		0x14,0x08,0x3e,0x08,0x14	; 2a *
				dt		0x08,0x08,0x3e,0x08,0x08	; 2b +
				dt		0x00,0x50,0x30,0x00,0x00	; 2c ,
				dt		0x08,0x08,0x08,0x08,0x08	; 2d -
				dt		0x00,0x60,0x60,0x00,0x00	; 2e .  (2)
				dt		0x20,0x10,0x08,0x04,0x02	; 2f /
				dt		0x3e,0x51,0x49,0x45,0x3e	; 30 0  (3)
				dt		0x00,0x42,0x7f,0x40,0x00	; 31 1  (4)
				dt		0x42,0x61,0x51,0x49,0x46	; 32 2  (5)
				dt		0x21,0x41,0x45,0x4b,0x31	; 33 3  (6)
				dt		0x18,0x14,0x12,0x7f,0x10	; 34 4  (7)
				dt		0x27,0x45,0x45,0x45,0x39	; 35 5  (8)
				dt		0x3c,0x4a,0x49,0x49,0x30	; 36 6	(9)
				dt		0x01,0x71,0x09,0x05,0x03	; 37 7	(10)
				dt		0x36,0x49,0x49,0x49,0x36	; 38 8	(11)
				dt		0x06,0x49,0x49,0x29,0x1e	; 39 9	(12)
				dt		0x00,0x36,0x36,0x00,0x00	; 3a :	(13)
				dt		0x00,0x56,0x36,0x00,0x00	; 3b ;
				dt		0x08,0x14,0x22,0x41,0x00	; 3c <
				dt		0x14,0x14,0x14,0x14,0x14	; 3d =
				dt		0x00,0x41,0x22,0x14,0x08	; 3e >
				dt		0x02,0x01,0x51,0x09,0x06	; 3f ?
				dt		0x32,0x49,0x79,0x41,0x3e	; 40 @
				dt		0x7e,0x11,0x11,0x11,0x7e	; 41 A	(14)
				dt		0x7f,0x49,0x49,0x49,0x36	; 42 B	(15)
				dt		0x3e,0x41,0x41,0x41,0x22	; 43 C
				dt		0x7f,0x41,0x41,0x22,0x1c	; 44 D

				dt		0x7f,0x49,0x49,0x49,0x41	; 45 E
				dt		0x7f,0x09,0x09,0x09,0x01	; 46 F	(16)
				dt		0x3e,0x41,0x49,0x49,0x7a	; 47 G
				dt		0x7f,0x08,0x08,0x08,0x7f	; 48 H
				dt		0x00,0x41,0x7f,0x41,0x00	; 49 I
				dt		0x20,0x40,0x41,0x3f,0x01	; 4a J	(17)
				dt		0x7f,0x08,0x14,0x22,0x41	; 4b K
				dt		0x7f,0x40,0x40,0x40,0x40	; 4c L
				dt		0x7f,0x02,0x0c,0x02,0x7f	; 4d M
				dt		0x7f,0x04,0x08,0x10,0x7f	; 4e N
				dt		0x3e,0x41,0x41,0x41,0x3e	; 4f O


				dt		0x7f,0x09,0x09,0x09,0x06	; 50 P
				dt		0x3e,0x41,0x51,0x21,0x5e	; 51 Q
				dt		0x7f,0x09,0x19,0x29,0x46	; 52 R
				dt		0x46,0x49,0x49,0x49,0x31	; 53 S	(18)
				dt		0x01,0x01,0x7f,0x01,0x01	; 54 T	(19)
				dt		0x3f,0x40,0x40,0x40,0x3f	; 55 U
				dt		0x1f,0x20,0x40,0x20,0x1f	; 56 V
				dt		0x3f,0x40,0x38,0x40,0x3f	; 57 W
				dt		0x63,0x14,0x08,0x14,0x63	; 58 X
				dt		0x07,0x08,0x70,0x08,0x07	; 59 Y
				dt		0x61,0x51,0x49,0x45,0x43	; 5a Z
				dt		0x00,0x7f,0x41,0x41,0x00	; 5b [
				dt		0x02,0x04,0x08,0x10,0x20	; 5c \
				dt		0x00,0x41,0x41,0x7f,0x00	; 5d
				dt		0x04,0x02,0x01,0x02,0x04	; 5e
				dt		0x40,0x40,0x40,0x40,0x40	; 5f
				dt		0x00,0x01,0x02,0x04,0x00	; 60
				dt		0x20,0x54,0x54,0x54,0x78	; 61 a	(20)
				dt		0x7f,0x48,0x44,0x44,0x38	; 62 b
				dt		0x38,0x44,0x44,0x44,0x20	; 63 c	(21)
				dt		0x38,0x44,0x44,0x48,0x7f	; 64 d
				dt		0x38,0x54,0x54,0x54,0x18	; 65 e	(22)
				dt		0x08,0x7e,0x09,0x01,0x02	; 66 f
				dt		0x0c,0x52,0x52,0x52,0x3e	; 67 g
				dt		0x7f,0x08,0x04,0x04,0x78	; 68 h	(23)
				dt		0x00,0x44,0x7d,0x40,0x00	; 69 i	(24)
				dt		0x20,0x40,0x44,0x3d,0x00	; 6a j 
				dt		0x7f,0x10,0x28,0x44,0x00	; 6b k
				dt		0x00,0x41,0x7f,0x40,0x00	; 6c l	(25)
				dt		0x7c,0x04,0x18,0x04,0x78	; 6d m	(26)
				dt		0x7c,0x08,0x04,0x04,0x78	; 6e n	(27)
				dt		0x38,0x44,0x44,0x44,0x38	; 6f o
				dt		0x7c,0x14,0x14,0x14,0x08	; 70 p
				dt		0x08,0x14,0x14,0x18,0x7c	; 71 q
				dt		0x7c,0x08,0x04,0x04,0x08	; 72 r	(28)
				dt		0x48,0x54,0x54,0x54,0x20	; 73 s
				dt		0x04,0x3f,0x44,0x40,0x20	; 74 t
				dt		0x3c,0x40,0x40,0x20,0x7c	; 75 u
				dt		0x1c,0x20,0x40,0x20,0x1c	; 76 v	(29)
				dt		0x3c,0x40,0x30,0x40,0x3c	; 77 w
				dt		0x44,0x28,0x10,0x28,0x44	; 78 x
				dt		0x0c,0x50,0x50,0x50,0x3c	; 79 y
				dt		0x44,0x64,0x54,0x4c,0x44	; 7a z
				dt		0x39,0x45,0x45,0x45,0x39	; 7b 
				dt		0x20,0x55,0x55,0x54,0x78	; 7c 
				dt		0x39,0x45,0x44,0x45,0x39	; 7d 
				dt		0x3c,0x41,0x41,0x20,0x7c	; 7e 
				dt		0x08,0x1C,0x3E,0x7F,0x00	; 7f sees tis <
				dt		0x00,0x7F,0x3E,0x1C,0x08	; 80 sees tis >
;				dt		0xA0,0xB0,0xB8,0xB0,0xA0	; 81 kolmnurk allkriipsuga
				dt		0x22,0x26,0x2E,0x26,0x22	; 81 kolmnurk allkriipsuga
;				dt		0x14,0x08,0x22,0x14,0x08	; 82 >>
	end			
;******************************************************************************
